/* name : SUBRATA  GHOSH
   Section VC

 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM
  
 *
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	7


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	14

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/*number of balloons at each click*/
#define NUM      5
/*max no of balloons*/
#define MAX_BALLOON  200

/*max no of boats*/
#define MAX_NUM_BOAT	3
/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed & */
/*create balloons*/

void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int car_direction[], int car_color[], int *num_balloon);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/*update coordinates of each balloon*/
void move_balloon(int balloon_x[][NUM],int balloon_y[][NUM], int num_balloon);



/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int x[], int y[], int direction[], int speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[], int y[], int color[]);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

/*draw balloons at each click with center balloon-x and balloon_y */
void draw_balloon(int balloon_x[][NUM], int balloon_y[][NUM], int num_balloon);


/*draw boat given their current coordinate x,y*/
void draw_boat (int x[], int y[]);

/*update boat position*/
void move_boat(int x[], int y[]);

/* Display error message if internal error is detected. */
void something_is_wrong (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/
    
	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

    /* information about balloon*/

    int balloon_x[MAX_BALLOON][NUM];   /*screen x_y coordinates*/
	int balloon_y[MAX_BALLOON][NUM]; 
												

    int num_balloon = 0;    /*intial no of click for
							creating balloons*/


    /*information about boat*/
   int boat_x[MAX_NUM_BOAT], boat_y[MAX_NUM_BOAT];


	/* Information about vehicles in the animation:						
	/* [Only one car now - will need to be changed to add more]*/
   
   
   
	int car_x[MAX_VEHICLES], car_y[MAX_VEHICLES];		/* current position
														of the car*/



	int car_direction[MAX_VEHICLES];       /* current direction: +1=right, 
	                                                -1=left*/
		
	int car_color[MAX_VEHICLES];        /*color of car*/



									
	int car_speed;			/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving"				*/

	int i,j;             /*input*/

	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

   

    /*initialization of car speed */
	car_speed = 5;

	traffic_moving = TRUE;
	
    /* initialize balloon position*/

    	  for( i = 0; i < MAX_BALLOON; i++){

              for(j = 1; j < NUM; j++){
             
	    	  balloon_x[i][j] = GP142_XMAX / 6;

		      balloon_y[i][j] = - HORIZON ;
              }
          }
         
   
      /*draw landscape,button first time*/    
	draw_landscape(sun_x,sun_y);

/*initial boat position*/
        for(i = 1; i < MAX_NUM_BOAT; i++){

              boat_x[i] = GP142_XMAX -   i * 100;
              boat_y[i] = - GP142_YMAX +  12;
          }
          draw_boat(boat_x, boat_y);



	draw_buttons( );



/* first time draw traffic at two road*/

for (i = 0; i < MAX_VEHICLES; i++){
    if(i<7){
	
		car_x[i] = i * 2 * CAR_WIDTH ;
		car_y[i] = HIGHWAY_CENTER;
		car_color[i] = i + RED;
		car_direction[i] = +1;
	
    }
		
    else{
         car_x[i] = (-i * 2 * CAR_WIDTH);
		 car_y[i]  = HIGHWAY_CENTER - 3 * HIGHWAY_WIDTH;
		 car_color[i] = i + GREEN;
		 car_direction[i] = -1;
	}
}
   draw_traffic(car_x,car_y,car_color);
	

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, &car_speed,
								car_direction, car_color, &num_balloon);

                   
			} else {
				
			}
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
            move_boat(boat_x, boat_y);
            
			if (traffic_moving)
				move_traffic(car_x, car_y, car_direction, car_speed);
			   
			 
			if(num_balloon > 0){
				move_balloon(balloon_x, balloon_y, num_balloon);
			}
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y);
      draw_boat(boat_x, boat_y);
		draw_buttons();
		draw_traffic(car_x, car_y, car_color);



		if(num_balloon > 0)
           
			draw_balloon(balloon_x, balloon_y, num_balloon);
            
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
  void draw_landscape(int sun_x, int sun_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */
    
	/* Draw the sky */
	GP142_rectangleXY(CYAN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 30);
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);

	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);

    GP142_rectangleXY(LT_GRAY,-GP142_XMAX,
		HIGHWAY_CENTER - 4 * HIGHWAY_WIDTH,
		GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
		FILL);

	GP142_rectangleXY(BLACK, -GP142_XMAX,HIGHWAY_CENTER - 3*HIGHWAY_WIDTH,
		GP142_XMAX,HIGHWAY_CENTER - 3*HIGHWAY_WIDTH + (NUM_BUTTONS/3),
		FILL);
	
		



/*Draw a black line  of thin width down the center of the road */ 

 GP142_rectangleXY(BLACK, -GP142_XMAX, 
	          HIGHWAY_CENTER - (NUM_BUTTONS / 3), 
	           GP142_XMAX, HIGHWAY_CENTER ,
						 FILL);


	                
	
	/*Draw some mountains */
	GP142_triangleXY(DUSTY_PLUM,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);

/*draw river*/
   GP142_ovalXY(ICE_BLUE,-GP142_XMAX, - GP142_YMAX - 15, 
          GP142_XMAX, -GP142_YMAX + 45, FILL);


GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");

 
/*draw some office building*/

GP142_rectangleXY(PEACH, -GP142_XMAX /2,
	  HORIZON,-GP142_XMAX/5 ,
	  GP142_YMAX/3,FILL);




GP142_triangleXY(PEACH, -GP142_XMAX/2,
				 GP142_YMAX/3,-GP142_XMAX/5,
				 GP142_YMAX/3,(-GP142_XMAX/3),
				 GP142_YMAX/2,FILL);

GP142_rectangleXY(PINK,(-GP142_XMAX/5)+2,HORIZON,
				  GP142_XMAX/6,GP142_YMAX/2,FILL);

GP142_circleXY(PINK,-4 ,GP142_YMAX/2,
			  23);

  }

/*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1) * BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");

    i -= BUTTON_HEIGHT;
 GP142_printfXY(RED, text_offset, i, font_size, "click-here");

 


}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
/*	else if(*/
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int car_direction[], int car_color[], int *num_balloon)
{
	int buttonNum,i;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse */
		for(i= 0; i < 14;i++){
		car_direction[i] = - car_direction[i];
		}
		break;
	case 5:
		/* change car color */
		for(i = 0; i < 14; i++){
		car_color[i] = (car_color[i]+1) % MAX_COLORS;
		}
		break;


    case 6:
        /*create balloons*/
        *num_balloon += 1;
        break;


	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}

}

/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */

void move_traffic(int x[], int y[], int direction[], int speed) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x,i;		/* new value for x coordinate */
     
	/* move vehicle.  If it reaches the edge  of the screen,
	 it drives off the edge ,then drives back from other side */		

	for ( i = 0; i < 14; i++){

        if(i<7){


            trial_x = x[i] + (direction[i] * speed);

	       if (abs(trial_x) > GP142_XMAX + CAR_WIDTH / 2 )	 
		
	          x[i] = trial_x - (2 * GP142_XMAX * direction[i]) ;
 	       else
		     x[i] = trial_x;
        }
     
        else {
              
	       trial_x = x[i] + (direction[i] * speed);
		if (abs(trial_x) > GP142_XMAX+ CAR_WIDTH / 2)  	 
		
	      x[i] = trial_x - (2 * GP142_XMAX * direction[i]) ;
    	else
		  x[i] = trial_x;
        }
     	

	
	}	
	
}






/* Draw all vehicles given their current x, y coordinates and color */


void draw_traffic(int x[], int y[], int color[] ) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */
int i;
    
	for (i = 0; i< 14; i++)	
	  draw_car( x[i],y[i],color[i]);
	


}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
  void draw_car(int x, int y, int color) {


	GP142_rectangleXY(color, x - CAR_WIDTH/2, y+ CAR_HEIGHT/4,
						x + CAR_WIDTH /2, y + CAR_HEIGHT*3/4, FILL);

	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);

	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, 
                                                 CAR_HEIGHT/4);

	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4,
                                                     CAR_HEIGHT/4);
}

/*draw balloon */
void draw_balloon(int balloon_x[][5],int balloon_y[][5], int num_balloon)
{
	int i,j;
for(i = 0; i < num_balloon ; i++){

    for(j = 1; j < NUM; j++){

      
	  GP142_circleXY(RED,balloon_x[i][j],balloon_y[i][j],20);


	  GP142_circleXY(YELLOW,balloon_x[i][j],balloon_y[i][j],10);
 
     GP142_circleXY(GREEN,balloon_x[i][j],balloon_y[i][j],5);

    GP142_circleXY(BLUE,balloon_x[i][j]+12,balloon_y[i][j]+12,9);
 
    GP142_circleXY(BLACK,balloon_x[i][j]+12,balloon_y[i][j]+12,2);
    }
} 

}

/*update balloons position*/
void move_balloon(int balloon_x[][5],int balloon_y[][5], int num_balloon)
{
  int j, i;	



    for(i = 0; i< num_balloon; i++){
        for(j = 1; j < NUM ; j++){
            if(j == 1){
	            balloon_x[i][j] = balloon_x[i][j] + BUTTON_HEIGHT  ;
                 balloon_y[i][j] = balloon_y[i][j];
            }
            if(j == 2){
	            balloon_x[i][j] = balloon_x[i][j] - BUTTON_HEIGHT ;
                balloon_y[i][j] = balloon_y[i][j];
            }
            if(j == 3){
	            balloon_x[i][j] = balloon_x[i][j] - NUM_BUTTONS ;
                balloon_y[i][j] = balloon_y[i][j] 
					                   + BUTTON_HEIGHT - NUM_BUTTONS ;
            }
            if(j == 4){
	           balloon_x[i][j] = balloon_x[i][j] + 2 * NUM_BUTTONS ;
              balloon_y[i][j] = balloon_y[i][j] 
				                      - BUTTON_HEIGHT - NUM_BUTTONS;
            }
        }
    }

		
		
	

}


/*draw boat*/
void draw_boat(int boat_x[], int boat_y[])
{
    int i;
    for(i = 1; i < MAX_NUM_BOAT; i++){
        
        GP142_triangleXY(MAGENTA, boat_x[i],boat_y[i], boat_x[i] - 40,
			boat_y[i] + 20, boat_x[i] + 40,boat_y[i] + 20, FILL);

	

		GP142_rectangleXY(GOLD,boat_x[i] - 4,boat_y[i] + 20,
			boat_x[i] + 4,boat_y[i] + 27, FILL);

	GP142_circleXY(BLACK,boat_x[i],boat_y[i] + 30, 6);

    }
}


/* update boats position*/
void move_boat(int boat_x[], int boat_y[])
{
    int i;
    for(i = 1; i < MAX_NUM_BOAT; i++){
        boat_x[i] = boat_x[i] - 1;
        
        if(boat_x[i] < - GP142_XMAX - 30){
            boat_x[i] = - boat_x[i];
        }
       
    
    }
  
}
/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}